Imports System.Data
Imports System.IO
Imports System.Data.SqlClient
Imports System.Security.Cryptography
Imports System.Web.Mail

Namespace ReUse
    Public Class CommonClass
        Public objConn As SqlConnection
        Private objDataReader As SqlDataReader
        Private objCommand As SqlCommand
        Dim dsDataSet As DataSet
        Private objAdapter As SqlDataAdapter
        Public Const const_DateFormat = "dd-MMM-yyyy"
        Public Function ErrCodetoMessage(ByVal ErrCode As Int32) As String
            Dim strErrorMessage As String
            Select Case ErrCode
                Case 1
                    strErrorMessage = "User does not exist"
                Case 2
                    strErrorMessage = "Incorrect Password"
                Case 3
                    strErrorMessage = "Invalid e-mail id"
                Case 4
                    strErrorMessage = "Required value"
                Case 5
                    strErrorMessage = "Numeric value"
                Case 6
                    strErrorMessage = "Password does not match"
            End Select
            ErrCodetoMessage = strErrorMessage
        End Function

        Enum errorcode
            UserDoesNotExist = 1
            PasswordDoesntMatch = 2
            InvalidEmail = 3
            RequiredValue = 4
            numericonly = 5
            PasswordNotMatch = 6
        End Enum

        Public Function GetUserName(ByVal strUser As String) As String
            Dim strSql = "Select * from mstMembers where UserName = '" & strUser & "'"
            Dim DR As SqlDataReader
            DR = GetDataReaderResultSet(strSql)
            If DR.Read Then
                GetUserName = DR("Title") & " " & DR("Fname") & " " & DR("LName") & ""
            Else
                GetUserName = ""
            End If
        End Function

        Public Function MakeConnection() As SqlConnection
            Dim blnOpenConnection As Boolean = False
            If IsNothing(objConn) Then
                objConn = New SqlConnection()
                blnOpenConnection = True
            ElseIf objConn.State = ConnectionState.Closed Or objConn.State = ConnectionState.Broken Then
                blnOpenConnection = True
            Else
                blnOpenConnection = False
            End If

            If blnOpenConnection Then
                objConn.ConnectionString = ConfigurationSettings.AppSettings("ConnectionString")
                objConn.Open()
            End If
        End Function

        Public Sub CloseConnection()
            If objConn.State = 1 Then
                objConn.Close()
                objConn.Dispose()
            End If
        End Sub

        Function GetMaxID(ByVal pType, ByVal delimchar)
            Dim sql, sMax, remLen
            Dim dread As SqlDataReader

            GetMaxID = "0"

            sql = "Select TOP 1 " & pType & " from sysLastCounters"

            Dim cmd As New SqlCommand(sql, objConn)

            dread = cmd.ExecuteReader

            If dread.Read Then
                GetMaxID = dread(pType)
                sMax = Mid(dread(pType), InStr(1, dread(pType), delimchar) + 1)

                remLen = 0
                remLen = Len(dread(pType)) - InStr(1, dread(pType), delimchar)

                sMax = CStr(CInt(sMax) + 1)
                sMax = Mid(dread(pType), 1, InStr(dread(pType), delimchar)) & Padl(sMax, remLen, "0")
                sql = "update sysLastCounters set " & pType & " = '" & sMax & "'"
                dread.Close()
                cmd.CommandText = sql
                cmd.ExecuteNonQuery()
            End If
            dread.Close()
            dread = Nothing
            GetMaxID = sMax
        End Function

        Function Padl(ByVal str, ByVal length, ByVal c)
            Dim mlen, i As Int32
            Dim mstr As String
            mlen = length - Len(str)
            If mlen <= 0 Then
                Padl = str
            Else
                mstr = ""
                For i = 1 To mlen
                    mstr = mstr + c
                Next
                Padl = mstr + str
            End If
        End Function

        Public Function GetDataReaderResultSet(ByVal strsql As String) As SqlDataReader
            objCommand = New SqlCommand()
            objCommand.Connection = objConn
            objCommand.CommandText = strsql
            objDataReader = objCommand.ExecuteReader()
            Return objDataReader
        End Function

        Public Function GetDataSetResultSet(ByVal strsql As String) As DataSet
            Dim strconn As String = ConfigurationSettings.AppSettings("ConnectionString")
            objAdapter = New SqlDataAdapter(strsql, strconn)
            dsDataSet = New DataSet()
            objAdapter.Fill(dsDataSet, "Table1")
            Return dsDataSet
        End Function

        Public Sub DisplayError(ByRef ErrException As Exception, ByRef objMe As Page)
            objMe.Response.Write("<LINK href='../Styles/Styles.css' type='text/css' rel='stylesheet'></LINK>")
            objMe.Response.Write("<span class=ErrorClass>Error Occured : Contact System Administrator " & "<br>")
            objMe.Response.Write("Message : " & ErrException.Message & "<br>")
            objMe.Response.Write("Trace : " & ErrException.StackTrace.ToString & "<br></span>")
            Call MakeLogFile(objMe, ErrException)
            objMe.Response.End()
        End Sub

        Public Sub MakeLogFile(ByRef objMe As Page, ByVal objpErr As Exception)
            Dim TextStream As StreamWriter
            Dim strPath As String
            strPath = objMe.Server.MapPath("../ErrLog/ErrLog.Log")
            TextStream = New StreamWriter(strPath, True)
            If Not objpErr Is Nothing Then
                TextStream.WriteLine("----------------------------------------------------------------------------------")
                TextStream.WriteLine("Date              : " & Format(Date.Today, "dd-MMM-yyyy") & Space(6) & Format(Date.Now, "HH:mm:ss"))
                TextStream.WriteLine("Err Message       : " & objpErr.Message)
                TextStream.WriteLine("Err Source        : " & objpErr.StackTrace.ToString)
                TextStream.WriteLine("----------------------------------------------------------------------------------")
            End If
            TextStream.Close()
        End Sub

        Public Function Decrypt(ByVal strText As String, ByVal sDecrKey As String) As String
            Dim byKey() As Byte = {}
            Dim IV() As Byte = {&H12, &H34, &H56, &H78, &H90, &HAB, &HCD, &HEF}
            Dim inputByteArray(strText.Length) As Byte
            Try
                byKey = System.Text.Encoding.UTF8.GetBytes(Mid(sDecrKey, 1, 8))
                Dim des As New DESCryptoServiceProvider()
                inputByteArray = Convert.FromBase64String(strText)
                Dim ms As New MemoryStream()
                Dim cs As New CryptoStream(ms, des.CreateDecryptor(byKey, IV), CryptoStreamMode.Write)
                cs.Write(inputByteArray, 0, inputByteArray.Length)
                cs.FlushFinalBlock()
                Dim encoding As System.Text.Encoding = System.Text.Encoding.UTF8
                Return encoding.GetString(ms.ToArray())
            Catch ex As Exception
                Return ex.Message
            End Try
        End Function

        Public Function Encrypt(ByVal strText As String, ByVal strEncrKey As String) As String
            Dim byKey() As Byte = {}
            Dim IV() As Byte = {&H12, &H34, &H56, &H78, &H90, &HAB, &HCD, &HEF}
            Try
                byKey = System.Text.Encoding.UTF8.GetBytes(Mid(strEncrKey, 1, 8))
                Dim des As New DESCryptoServiceProvider()
                Dim inputByteArray() As Byte = System.Web.HttpContext.Current.Response.ContentEncoding.UTF8.GetBytes(strText)
                Dim ms As New MemoryStream()
                Dim cs As New CryptoStream(ms, des.CreateEncryptor(byKey, IV), CryptoStreamMode.Write)
                cs.Write(inputByteArray, 0, inputByteArray.Length)
                cs.FlushFinalBlock()
                Return Convert.ToBase64String(ms.ToArray())
            Catch ex As Exception
                Return ex.Message
            End Try
        End Function

        Sub ValidateMember(ByVal strRedirectTo As String)
            System.Web.HttpContext.Current.Response.Expires = 0
            If System.Web.HttpContext.Current.Session("UserMemberID") = "" Or System.Web.HttpContext.Current.Session("UserMemberID") = Nothing Then
                System.Web.HttpContext.Current.Response.Redirect("..\Default.aspx?frm=" & strRedirectTo)
            End If
        End Sub

        Sub ValidateAdmin(ByVal strRedirectTo As String)
            System.Web.HttpContext.Current.Response.Expires = 0
            If System.Web.HttpContext.Current.Session("AdminID") = "" Or System.Web.HttpContext.Current.Session("AdminID") = Nothing Then
                System.Web.HttpContext.Current.Response.Redirect("..\Admin\Default.aspx?frm=" & strRedirectTo)
            End If
        End Sub

        Function FixQuotes(ByVal str As String)
            str = Replace(str, "'", "''")
            Return str
        End Function

        Function IfEMailExists(ByVal strEml As String, ByVal strReturnFld As String, ByVal tmpConn As SqlConnection, Optional ByVal tmpTrn As SqlTransaction = Nothing) As String

            Dim cmd As New SqlCommand()
            Dim strTmp, strSQl As String

            strSQl = "Select " & strReturnFld & " from mstMembers where PresentEmail = '" & strEml & "' OR PermanentEmail = '" & strEml & "'"

            cmd.Connection = tmpConn
            If Not IsNothing(tmpTrn) Then
                cmd.Transaction = tmpTrn
            End If
            cmd.CommandType = CommandType.Text
            cmd.CommandText = strSQl
            strTmp = cmd.ExecuteScalar
            If Not IsDBNull(strTmp) Then
                IfEMailExists = strTmp
            Else
                IfEMailExists = ""
            End If
            cmd.Dispose()
        End Function

        Function FriendAlready(ByVal strMemberID As String, ByVal strFriendID As String, ByVal tmpConn As SqlConnection, Optional ByVal tmpTrn As SqlTransaction = Nothing, Optional ByVal strStatus As String = "") As Boolean
            Dim cmd As New SqlCommand()
            Dim strTmp, strSQl As String
            If strStatus > "" Then
                strSQl = "Select FriendID from detMemberFriends where MemberID = '" & strMemberID & "' AND FriendID = '" & strFriendID & "' AND Status IN (" & strStatus & ")"
            Else
                strSQl = "Select FriendID from detMemberFriends where MemberID = '" & strMemberID & "' AND FriendID = '" & strFriendID & "'"
            End If

            cmd.Connection = tmpConn
            If Not IsNothing(tmpTrn) Then
                cmd.Transaction = tmpTrn
            End If
            cmd.CommandType = CommandType.Text
            cmd.CommandText = strSQl

            strTmp = cmd.ExecuteScalar

            If Not IsDBNull(strTmp) Then
                If strTmp > "" Then
                    FriendAlready = True
                Else
                    FriendAlready = False
                End If
            Else
                FriendAlready = False
            End If

            cmd.Dispose()

        End Function

        Function ContactAlready(ByVal strMemberID As String, ByVal strFriendID As String, ByVal tmpConn As SqlConnection, Optional ByVal tmpTrn As SqlTransaction = Nothing) As String

            Dim cmd As New SqlCommand()
            Dim strTmp, strSQl As String

            strSQl = "Select ContactID from detMemberContacts where MemberID = '" & strMemberID & "' AND ContactMemberID = '" & strFriendID & "'"


            cmd.Connection = tmpConn
            If Not IsNothing(tmpTrn) Then
                cmd.Transaction = tmpTrn
            End If
            cmd.CommandType = CommandType.Text
            cmd.CommandText = strSQl

            strTmp = cmd.ExecuteScalar

            If Not IsDBNull(strTmp) Then
                If strTmp > "" Then
                    ContactAlready = strTmp
                Else
                    ContactAlready = ""
                End If
            Else
                ContactAlready = ""
            End If

            cmd.Dispose()

        End Function

        Function GetMemberField(ByVal strField As String, ByVal strWhereFld As String, ByVal strWhereVal As String, ByVal tmpConn As SqlConnection, Optional ByVal tmpTrn As SqlTransaction = Nothing) As String

            Dim cmd As New SqlCommand()
            Dim strTmp, strSQl As String

            strSQl = "Select " & strField & " from mstMembers where " & strWhereFld & " = '" & strWhereVal & "'"

            cmd.Connection = tmpConn
            If Not IsNothing(tmpTrn) Then
                cmd.Transaction = tmpTrn
            End If
            cmd.CommandType = CommandType.Text
            cmd.CommandText = strSQl

            strTmp = cmd.ExecuteScalar

            If Not IsDBNull(strTmp) Then
                GetMemberField = strTmp
            Else
                GetMemberField = ""
            End If

            cmd.Dispose()

        End Function

        Function GetCount(ByVal strTable As String, ByVal strField As String, ByVal strWhereText As String, ByVal tmpConn As SqlConnection, Optional ByVal tmpTrn As SqlTransaction = Nothing) As String

            Dim cmd As New SqlCommand()
            Dim strTmp, strSQl As String

            strSQl = "Select Count(" & strField & ") from " & strTable & " " & strWhereText

            cmd.Connection = tmpConn
            If Not IsNothing(tmpTrn) Then
                cmd.Transaction = tmpTrn
            End If
            cmd.CommandType = CommandType.Text
            cmd.CommandText = strSQl

            strTmp = cmd.ExecuteScalar

            If Not IsDBNull(strTmp) Then
                GetCount = strTmp
            Else
                GetCount = ""
            End If

            cmd.Dispose()

        End Function

        Public Sub SendMail(ByVal MailBody As String, ByVal MailSub As String, ByVal MailTo As String, ByVal MailFrom As String, ByVal MailCC As String, ByVal MailBcc As String, ByVal strFileToAttach As String, ByVal IsHTML As Boolean)
            Dim myMail As SmtpMail

            'Create the message object.
            Dim MailMsg As CDO.Message = New CDO.Message()

            'Create the configuration object.
            Dim iConf = MailMsg.Configuration

            With iConf.Fields
                .item("http://schemas.microsoft.com/cdo/configuration/sendusing") = 1 'cdoSendUsingPickup
                .item("http://schemas.microsoft.com/cdo/configuration/smtpserverpickupdirectory") = ConfigurationSettings.AppSettings("MailPickupdirectory")
                .Update()
            End With


            MailMsg.From = MailFrom
            MailMsg.To = MailTo


            If Not MailCC.Trim.Equals("") Then
                MailMsg.CC = MailCC
            End If

            If Not MailBcc.Trim.Equals("") Then
                MailMsg.BCC = MailBcc
            End If

            If Not strFileToAttach.Trim.Equals("") Then
                MailMsg.AddAttachment(strFileToAttach)
                'MailMsg.Attachments.Item(1).
            End If


            MailMsg.Subject = MailSub
            If IsHTML Then
                MailMsg.HTMLBody = MailBody
            Else
                MailMsg.TextBody = MailBody
            End If
            MailMsg.Send()

            MailMsg = Nothing
            myMail = Nothing
        End Sub

        Function ValidateEmail(ByVal strEmail As String) As Boolean
            Dim goby
            goby = 0 'Initializing goby to 0

            'if the len is less than 5 then it can't be an email
            '(i.e.: a@a.c) 
            If Len(strEmail) <= 5 Then
                goby = 1
            End If

            If InStr(1, strEmail, "@", 1) < 2 Then
                'If we find one and only one @, then the
                'email address is good to go.
                goby = 1
            Else
                If InStr(1, strEmail, ".", 1) < 4 Then
                    'Must have a '.' too
                    goby = 1
                End If
            End If

            If goby <> 0 Then
                'Well , if goby <> 0 then something 
                'must be wrong
                Return False
            Else
                Return True
            End If

        End Function

        Function GetDataExecuteScalar(ByVal strSql As String, ByVal tmpConn As SqlConnection, Optional ByVal tmpTrn As SqlTransaction = Nothing) As String

            Dim cmd As New SqlCommand()

            cmd.Connection = tmpConn
            If Not IsNothing(tmpTrn) Then
                cmd.Transaction = tmpTrn
            End If
            cmd.CommandType = CommandType.Text
            cmd.CommandText = strSql

            GetDataExecuteScalar = cmd.ExecuteScalar

            cmd.Dispose()

        End Function

        Function GetNetworkField(ByVal strField As String, ByVal strWhereFld As String, ByVal strWhereVal As String, ByVal tmpConn As SqlConnection, Optional ByVal tmpTrn As SqlTransaction = Nothing) As String

            Dim cmd As New SqlCommand()
            Dim strTmp, strSQl As String

            strSQl = "Select " & strField & " from mstNetworks where " & strWhereFld & " = '" & strWhereVal & "'"

            cmd.Connection = tmpConn
            If Not IsNothing(tmpTrn) Then
                cmd.Transaction = tmpTrn
            End If
            cmd.CommandType = CommandType.Text
            cmd.CommandText = strSQl

            strTmp = cmd.ExecuteScalar

            If Not IsDBNull(strTmp) Then
                GetNetworkField = strTmp
            Else
                GetNetworkField = ""
            End If

            cmd.Dispose()

        End Function

        Public Function GetRandomNumber(ByVal StartPt As Integer, ByVal EndPt As Integer, Optional ByVal DupNo As Integer = -1) As Integer
            Dim GeneratedRandom As Integer
            GeneratedRandom = Int((EndPt * Rnd()))
            Return GeneratedRandom
        End Function

        'Public Sub DisplayError(ByRef ErrException As Exception, ByRef objMe As Page)
        '    objMe.Response.Write("<LINK href='../Styles/Styles.css' type='text/css' rel='stylesheet'></LINK>")
        '    objMe.Response.Write("<span class=ErrorClass>Error Occured : Contact System Administrator " & "<br>")
        '    objMe.Response.Write("Message : " & ErrException.Message & "<br>")
        '    objMe.Response.Write("Trace : " & ErrException.StackTrace.ToString & "<br></span>")
        '    Call MakeLogFile(objMe, ErrException)
        '    objMe.Response.End()
        'End Sub

    End Class


End Namespace

